<a id="mypy-boto3-resiliencehub"></a>

# mypy-boto3-resiliencehub

[![PyPI - mypy-boto3-resiliencehub](https://img.shields.io/pypi/v/mypy-boto3-resiliencehub.svg?color=blue)](https://pypi.org/project/mypy-boto3-resiliencehub)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-resiliencehub.svg?color=blue)](https://pypi.org/project/mypy-boto3-resiliencehub)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-resiliencehub?color=blue)](https://pypistats.org/packages/mypy-boto3-resiliencehub)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.ResilienceHub 1.20.35](https://boto3.amazonaws.com/v1/documentation/api/1.20.35/reference/services/resiliencehub.html#ResilienceHub)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.3.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-resiliencehub docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_resiliencehub/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-resiliencehub](#mypy-boto3-resiliencehub)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `ResilienceHub`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `ResilienceHub` service.

```bash
python -m pip install boto3-stubs[resiliencehub]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[resiliencehub]` in your environment:
  `python -m pip install 'boto3-stubs[resiliencehub]'`

Both type checking and auto-complete should work for `ResilienceHub` service.
No explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[resiliencehub]` in your environment:
  `python -m pip install 'boto3-stubs[resiliencehub]'`

Both type checking and auto-complete should work for `ResilienceHub` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[resiliencehub]` in your environment:
  `python -m pip install 'boto3-stubs[resiliencehub]'`
- Run `mypy` as usual

Type checking should work for `ResilienceHub` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[resiliencehub]` in your environment:
  `python -m pip install 'boto3-stubs[resiliencehub]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `ResilienceHub` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`ResilienceHubClient` provides annotations for `boto3.client("resiliencehub")`.

```python
import boto3

from mypy_boto3_resiliencehub import ResilienceHubClient

client: ResilienceHubClient = boto3.client("resiliencehub")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ResilienceHubClient = session.client("resiliencehub")
```

<a id="literals"></a>

### Literals

`mypy_boto3_resiliencehub.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_resiliencehub.literals import (
    AlarmTypeType,
    AppComplianceStatusTypeType,
    AppStatusTypeType,
    AssessmentInvokerType,
    AssessmentStatusType,
    ComplianceStatusType,
    ConfigRecommendationOptimizationTypeType,
    CostFrequencyType,
    DataLocationConstraintType,
    DisruptionTypeType,
    EstimatedCostTierType,
    HaArchitectureType,
    PhysicalIdentifierTypeType,
    RecommendationComplianceStatusType,
    RecommendationTemplateStatusType,
    RenderRecommendationTypeType,
    ResiliencyPolicyTierType,
    ResourceImportStatusTypeType,
    ResourceMappingTypeType,
    ResourceResolutionStatusTypeType,
    SopServiceTypeType,
    TemplateFormatType,
    TestRiskType,
    TestTypeType,
    ServiceName,
)

def check_value(value: AlarmTypeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_resiliencehub.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_resiliencehub.type_defs import (
    AddDraftAppVersionResourceMappingsRequestRequestTypeDef,
    AddDraftAppVersionResourceMappingsResponseTypeDef,
    AlarmRecommendationTypeDef,
    AppAssessmentSummaryTypeDef,
    AppAssessmentTypeDef,
    AppComponentComplianceTypeDef,
    AppComponentTypeDef,
    AppSummaryTypeDef,
    AppTypeDef,
    AppVersionSummaryTypeDef,
    ComponentRecommendationTypeDef,
    ConfigRecommendationTypeDef,
    CostTypeDef,
    CreateAppRequestRequestTypeDef,
    CreateAppResponseTypeDef,
    CreateRecommendationTemplateRequestRequestTypeDef,
    CreateRecommendationTemplateResponseTypeDef,
    CreateResiliencyPolicyRequestRequestTypeDef,
    CreateResiliencyPolicyResponseTypeDef,
    DeleteAppAssessmentRequestRequestTypeDef,
    DeleteAppAssessmentResponseTypeDef,
    DeleteAppRequestRequestTypeDef,
    DeleteAppResponseTypeDef,
    DeleteRecommendationTemplateRequestRequestTypeDef,
    DeleteRecommendationTemplateResponseTypeDef,
    DeleteResiliencyPolicyRequestRequestTypeDef,
    DeleteResiliencyPolicyResponseTypeDef,
    DescribeAppAssessmentRequestRequestTypeDef,
    DescribeAppAssessmentResponseTypeDef,
    DescribeAppRequestRequestTypeDef,
    DescribeAppResponseTypeDef,
    DescribeAppVersionResourcesResolutionStatusRequestRequestTypeDef,
    DescribeAppVersionResourcesResolutionStatusResponseTypeDef,
    DescribeAppVersionTemplateRequestRequestTypeDef,
    DescribeAppVersionTemplateResponseTypeDef,
    DescribeDraftAppVersionResourcesImportStatusRequestRequestTypeDef,
    DescribeDraftAppVersionResourcesImportStatusResponseTypeDef,
    DescribeResiliencyPolicyRequestRequestTypeDef,
    DescribeResiliencyPolicyResponseTypeDef,
    DisruptionComplianceTypeDef,
    FailurePolicyTypeDef,
    ImportResourcesToDraftAppVersionRequestRequestTypeDef,
    ImportResourcesToDraftAppVersionResponseTypeDef,
    ListAlarmRecommendationsRequestRequestTypeDef,
    ListAlarmRecommendationsResponseTypeDef,
    ListAppAssessmentsRequestRequestTypeDef,
    ListAppAssessmentsResponseTypeDef,
    ListAppComponentCompliancesRequestRequestTypeDef,
    ListAppComponentCompliancesResponseTypeDef,
    ListAppComponentRecommendationsRequestRequestTypeDef,
    ListAppComponentRecommendationsResponseTypeDef,
    ListAppVersionResourceMappingsRequestRequestTypeDef,
    ListAppVersionResourceMappingsResponseTypeDef,
    ListAppVersionResourcesRequestRequestTypeDef,
    ListAppVersionResourcesResponseTypeDef,
    ListAppVersionsRequestRequestTypeDef,
    ListAppVersionsResponseTypeDef,
    ListAppsRequestRequestTypeDef,
    ListAppsResponseTypeDef,
    ListRecommendationTemplatesRequestRequestTypeDef,
    ListRecommendationTemplatesResponseTypeDef,
    ListResiliencyPoliciesRequestRequestTypeDef,
    ListResiliencyPoliciesResponseTypeDef,
    ListSopRecommendationsRequestRequestTypeDef,
    ListSopRecommendationsResponseTypeDef,
    ListSuggestedResiliencyPoliciesRequestRequestTypeDef,
    ListSuggestedResiliencyPoliciesResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    ListTestRecommendationsRequestRequestTypeDef,
    ListTestRecommendationsResponseTypeDef,
    ListUnsupportedAppVersionResourcesRequestRequestTypeDef,
    ListUnsupportedAppVersionResourcesResponseTypeDef,
    LogicalResourceIdTypeDef,
    PhysicalResourceIdTypeDef,
    PhysicalResourceTypeDef,
    PublishAppVersionRequestRequestTypeDef,
    PublishAppVersionResponseTypeDef,
    PutDraftAppVersionTemplateRequestRequestTypeDef,
    PutDraftAppVersionTemplateResponseTypeDef,
    RecommendationDisruptionComplianceTypeDef,
    RecommendationItemTypeDef,
    RecommendationTemplateTypeDef,
    RemoveDraftAppVersionResourceMappingsRequestRequestTypeDef,
    RemoveDraftAppVersionResourceMappingsResponseTypeDef,
    ResiliencyPolicyTypeDef,
    ResiliencyScoreTypeDef,
    ResolveAppVersionResourcesRequestRequestTypeDef,
    ResolveAppVersionResourcesResponseTypeDef,
    ResourceMappingTypeDef,
    ResponseMetadataTypeDef,
    S3LocationTypeDef,
    SopRecommendationTypeDef,
    StartAppAssessmentRequestRequestTypeDef,
    StartAppAssessmentResponseTypeDef,
    TagResourceRequestRequestTypeDef,
    TestRecommendationTypeDef,
    UnsupportedResourceTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateAppRequestRequestTypeDef,
    UpdateAppResponseTypeDef,
    UpdateResiliencyPolicyRequestRequestTypeDef,
    UpdateResiliencyPolicyResponseTypeDef,
)

def get_structure() -> AddDraftAppVersionResourceMappingsRequestRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-resiliencehub` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-resiliencehub docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_resiliencehub/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
